main = let n = 10^100 in print $ sum $ map (\(k,s) ->
  sum $ map (\t -> (length $ takeWhile (<=n) $ map fst 
  $ iterate (\(a,b) -> (b,k*b-a)) t) - 2) $ concat s)
  [(14,[[(79,7),(19,7),(67,7),(31,7),(133,13),(49,13),
  (237,21),(57,21),(163,19),(103,19),(201,21),(93,21),
  (457,37),(61,37),(395,35),(95,35),(283,31),(151,31),
  (511,43),(91,43),(335,35),(155,35),(399,39),(147,39),
  (577,49),(109,49),(301,37),(217,37),(553,49),(133,49),
  (379,43),(223,43),(469,49),(217,49),(889,73),(133,73),
  (711,63),(171,63)],[(i,i) | i <- [1,3..99]]]), (4,let
  xs = [(13,14),(14,19),(26,28),(26,31),(28,38),(39,42),
       (38,61),(42,57),(52,56),(52,62),(49,74)] in [xs,
  map (\(a,b) -> (b,a)) xs, [(i,i+i) | i <- [1..50]]])]

